/****************************************************************** 
 * Copyright (c) 2003, Mario Hochreiter, Student of 
 * Software Engineering at FH-Hagenberg, Austria. 
 * Project member of the isac team at the Institute for 
 * Software-Technologie, Graz University of Technology, Austria. 
 * 
 * Use is subject to license terms.
 ******************************************************************/

package isac.gui.browser.panels;

import isac.gui.util.Hierarchy;
import isac.gui.util.MethodNode;
import isac.useractions.IUIAction;
import isac.useractions.IUserAction;

import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.rmi.RemoteException;

import javax.swing.JFrame;
import javax.swing.tree.TreePath;

/**
 * @author Mario Hochreiter, JL
 * @version 0.1
 *  
 */
public class MethodBrowserPanel extends TabPanel {

    public MethodBrowserPanel(JFrame root, Hierarchy hierarchy) {
        super(root, hierarchy);
        this.initMouseListener();
    }

    protected void initMouseListener() {
        ml_ = new MouseAdapter() {

            public void mousePressed(MouseEvent e) {
                int selRow = view_tree_.getRowForLocation(e.getX(), e.getY());
                TreePath selPath = view_tree_.getPathForLocation(e.getX(), e
                        .getY());
                if (selRow != -1) {
                    if (e.getClickCount() == 2) {
                        MethodNode selNode = (MethodNode) selPath
                                .getLastPathComponent();
                        ContentPanel cp = root_.getContentPanel();
                        if (selNode.getContentref() != null) {
                            cp.setContent("met", selNode.getContentref());
                        } else if (selNode.getNo() != null) {
                            cp.setContent("met", selNode.getNo());
                        }
                        root_.showContentFrame();
                    }
                }
            }
        };
        view_tree_.addMouseListener(ml_);
    }

	/* (non-Javadoc)
	 * @see isac.interfaces.IToGUI#activateUIObject(int, boolean)
	 */
	public void activateUIObject(int id, boolean active) throws RemoteException {
		// TODO Auto-generated method stub
		
	}

	/* (non-Javadoc)
	 * @see isac.interfaces.IToGUI#doUIAction(isac.useractions.IUserAction)
	 */
	public boolean doUIAction(IUserAction action) throws RemoteException {
		// TODO Auto-generated method stub
		return false;
	}

	/* (non-Javadoc)
	 * @see isac.interfaces.IToGUI#doUIAction(isac.useractions.IUIAction)
	 */
	public void doUIAction(IUIAction action) throws RemoteException {
		// TODO Auto-generated method stub
		
	}

	/* (non-Javadoc)
	 * @see isac.interfaces.IToGUI#addUIElement(isac.useractions.IUIAction)
	 */
	public void addUIElement(IUIAction action) throws RemoteException {
		// TODO Auto-generated method stub
		
	}

	/* (non-Javadoc)
	 * @see isac.interfaces.IToGUI#removeUIElement(isac.useractions.IUIAction)
	 */
	public boolean removeUIElement(IUIAction action) throws RemoteException {
		// TODO Auto-generated method stub
		return false;
	}
}