/*
 * @author Manuel Koschuch, member of the ISAC-team, 
 * Copyright (c) 2005 by Manuel Koschuch
 * created Aug 9, 2005 3:15:19 PM
 * Institute for Softwaretechnology, Graz University of Technology, Austria.
 * 
 * Use is subject to PGPL license terms.
 */
package isac.useractions;

import isac.interfaces.ICalcElement;

/**
 * Describes a user-interface action which has to pass a CalcElement for display
 * on the gui.
 * 
 * @see isac.useractions.UIActionOnIterator
 * @see isac.useractions.UIActionNewProblemForBrowser
 * @author Manuel Koschuch
 */
public class UIActionOnCalcElement extends UIAction {
    private ICalcElement calc_element_;

    public UIActionOnCalcElement(int action, int context, ICalcElement element) {
        super(action, context);
        calc_element_ = element;
    }

    public ICalcElement getCalcElement() {
        return calc_element_;
    }

}